from sys import stdout

def gcd(a, b):
    if b == 0:
        return a
    return gcd(b, a % b)

def lcm(a, b):
    return a * b // gcd(a, b)
    
def get_query(x):
    if x > MAX:
        return [0, 1]
    print('X', x)
    stdout.flush()
    return [int(i) for i in input().split()]
    
def print_answer(n):
    print('N', n)
    stdout.flush()    
    s = input()   

def is_prime(n):
    i = 2
    while i * i <= n:
        if n % i == 0:
            return False;
        i += 1
    return True

def next_prime(n):
    i = n + 1
    while not is_prime(i):
        i += 1
    return i

def guess():
    k = 20
    
    p = 2
    ans = 1
    for i in range(k):
        a, b = get_query(p)
        ans = lcm(ans, b)
        p = next_prime(p)
    print_answer(ans)

g = int(input())

MIN = 1
MAX = 10 ** 18

for i in range(g):
    guess()
