#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>
#include "testlib.h"

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

int main(int argc, char ** argv) {
	registerGen(argc, argv, 1);

	if (argc != 6) {
		cerr << "Usage: g, q, min_n, max_n, mult" << endl;

		return 1;
	}

	int g = atoi(argv[1]);
	int q = atoi(argv[2]);
	long long min_n = atoll(argv[3]);
	long long max_n = atoll(argv[4]);
	long long mult = atoll(argv[5]);

    vector<long long> ns;
    for (int i = 0; i < g; i++)
        ns.push_back(rnd.next(min_n, max(1ll, max_n / mult)) * mult);

    printf("%d %d\n", g, q);
    for (int i = 0; i < g; i++)
        printf("%lld\n", ns[i]);

    return 0;
}
