from sys import stdout

def gcd(a, b):
    if b == 0:
        return a
    return gcd(b, a % b)

def lcm(a, b):
    return a * b // gcd(a, b)

def get_query(x):
    if x > MAX:
        return [0, 1]
    print('X', x)
    stdout.flush()
    return [int(i) for i in input().split()]
    
def print_answer(n):
    print('N', n)
    stdout.flush()    
    s = input()    

def guess():
    biggest_divisor = 1
    while True:
        a, b = get_query(biggest_divisor + 1)
        if a == 0:
            print_answer(biggest_divisor)
            return
        biggest_divisor = lcm(biggest_divisor, b)

g = int(input())

MIN = 1
MAX = 10 ** 18

for i in range(g):
    guess()
